#include <iostream>
#include <stdlib.h>

using namespace std;

bool czy_parzysta(int liczba)  // sprawdza, czy liczba jest parzysta
{
    return (liczba % 2) == 0;
}

struct element_listy  // struktura reprezentujaca element listy
{
    int wartosc;
    element_listy *nastepny;             
};

element_listy *glowa;

void dodaj_do_listy(int liczba) //funkcja dodajaca element do listy
{
    element_listy *nowy_element = new element_listy; // tworzony jest nowy element
    nowy_element->wartosc = liczba; // wypelniana jest wartosc elementu
    nowy_element->nastepny = NULL; // wartosc NULL sygnalizuje, ze element nie posiada nastepnika

    if(glowa == NULL) // jezeli nie ma zadnego elementu na liscie
    {
        glowa = nowy_element; // nowy element staje sie pierwszym elementem na liscie
    } 
    else 
    {
        // jezeli sa juz elementy na liscie stworz tymczasowy wskaznik wskazujacy na poczatek listy
        element_listy *temp = glowa;
        // przesuwamy tymczasowy wskaznik dopoki istnieje element nastepny
        while (temp->nastepny)
        {
            temp = temp->nastepny;
        }
        temp->nastepny = nowy_element;  // ostatni element wskazuje na nowo dodany 
    }           
}


int main()
{
    int liczba_spr = 0;
    char* bufor = new char [100];
    cout << "Uwaga: Aby zakonczyc, nacisnij ENTER bez podania liczby" << endl;
    do 
    {
        cout << "Podaj liczbe: ";
        cin.getline(bufor, 100);
        
        if(*bufor != '\0')               	 // jezeli bufor nie pusty
        {  
			int liczba = atoi (bufor);       // konwertuj z tablicy znakow na liczbe
            dodaj_do_listy(liczba); 		 // dodaj do listy
        } 
        
    } while(*bufor != '\0');
    
    cout<<"\nLiczby parzyste: ";
    element_listy *temp = glowa; // toworzymy tymczasowy wskaznik do wskazywania aktualnego elementu na liscie

    while (temp) // dopoki element rozny od NULL
    {
        if(czy_parzysta(temp->wartosc)) // wypisz liczbe jezeli parzysta
        {
            cout<<temp->wartosc<<", ";                                      
        }  
        temp = temp->nastepny; // niech tymczasowy wskaznik wskazuje na nastepny element na liscie
    }
    delete glowa;
    glowa = NULL;
    cout << endl << "\n\nNacisnij ENTER, aby kontynuowac...";
    cin.get();
    return 0;
}
